varying vec3 normal,v,lightVec;
uniform bool mode;
uniform sampler2D tex0;
uniform sampler2DShadow texShadow;
	
void main() {
	vec4 texture0 = texture2D(tex0, gl_TexCoord[0].st);
	vec4 coord = gl_TexCoord[1];
	float offset = (.0013 + (1.0-abs(dot(normal,lightVec)))*.005)*coord.w;
	coord.z -= offset;
	vec4 shadow = shadow2DProj(texShadow, coord);

	vec3 E = normalize(-v);
	vec3 R = normalize(-reflect(lightVec, normal));
	vec4 color = gl_FrontLightModelProduct.sceneColor;
	color += gl_FrontLightProduct[0].ambient;
	color += shadow * gl_FrontLightProduct[0].diffuse * max(dot(normal,lightVec),.0);
	color += shadow * gl_FrontLightProduct[0].specular * pow(max(dot(R, E), 0.0), gl_FrontMaterial.shininess);
	gl_FragColor = mode ? color*texture0 : shadow;
}